#jinja2: lstrip_blocks: True, trim_blocks: True
version: '3.8'

services:
  traefik:
    hostname: traefik
    image: traefik:{{ version_tag | default('latest') }}
    command:
      # - "--log.level=DEBUG"
      - "--api=true"
      - "--api.insecure=true"
      - "--api.dashboard=true"
      - "--providers.docker.endpoint=unix:///var/run/docker.sock"
      - "--providers.docker.swarmMode=true"
      - "--providers.docker.exposedbydefault=false"
      - "--providers.docker.network=traefik_proxy"
      - "--entrypoints.http.address=:80"
      - "--entrypoints.https.address=:443"
{% if enable_letsencrypt is defined and enable_letsencrypt == True %}
      - "--certificatesresolvers.le.acme.httpchallenge=true"
      - "--certificatesresolvers.le.acme.httpchallenge.entrypoint=http"
      - "--certificatesresolvers.le.acme.email={{ traefik_acme_email | mandatory }}"
      - "--certificatesresolvers.le.acme.storage=/letsencrypt/acme.json"
{% endif %}
      # - "--api.insecure=true"
{% if insecure_skip_verify is defined and insecure_skip_verify == True %}
      # Options needed to connect to containers that use self-signed certificates
      - "--serversTransport.insecureSkipVerify=true"
      - "--providers.http.tls.insecureskipverify=true"
{% endif %}
    ports:
      # To be able to see the client's real IP we need to bind ports like this
      # so ports are not controlled by swarm's mesh network
      # https://dockerswarm.rocks/traefik/#getting-the-client-ip
      - target: 80
        published: 80
        mode: host
      - target: 443
        published: 443
        mode: host
      # Use this if direct access to traefik dashboard is needed
      # - target: 8080
      #   published: 8080
      #   mode: host
    dns:
      - 1.1.1.1
    deploy:
      placement:
        constraints:
          - node.role == manager
      labels:
        # Dashboard
        - "traefik.enable=true"
        - "traefik.http.services.dashboard.loadbalancer.server.port=8080"
        - "traefik.http.routers.traefik.service=dashboard"
        - "traefik.http.routers.traefik.rule=Host(`{{ environments[env].service_hostname | mandatory }}`)"
        - "traefik.http.routers.traefik.service=api@internal"
{% if admin_password is defined and admin_password != "" %}
        # Only added if user and password are set on manifest file
        - "traefik.http.routers.traefik.middlewares=auth"
        - "traefik.http.middlewares.auth.basicauth.users={{ environments[env].admin_username | default('admin') }}:{{ admin_password | password_hash('bcrypt') | replace('$','$$') }}"
{% endif %}
{% if enable_letsencrypt is defined and enable_letsencrypt == True %}
        # Letsencrypt
        - "traefik.http.routers.traefik.tls.certresolver=le"
        - "traefik.http.routers.traefik.entrypoints=https"
        - "traefik.http.routers.traefik.tls=true"
{% endif %}
        # Redirect a https global
        - "traefik.http.routers.http-catchall.rule=hostregexp(`{host:.+}`)"
        - "traefik.http.routers.http-catchall.entrypoints=http"
        - "traefik.http.routers.http-catchall.middlewares=redirect-to-https"
        - "traefik.http.routers.http-catchall.middlewares=redirect-to-https@docker"
        # Redirect del middleware
        - "traefik.http.middlewares.redirect-to-https.redirectscheme.scheme=https"
      update_config:
        parallelism: {{ environments[env].update_config.parallelism | default('2') }}
        delay: {{ environments[env].update_config.delay | default('10s') }}
        order: start-first
        failure_action: rollback
      restart_policy:
        condition: on-failure
{% if enable_resources is defined and enable_resources == True %}
      resources:
        limits:
          memory: {{ environments[env].resources.limits.memory | default('1024m') }}
        reservations:
          memory: {{ environments[env].resources.reservations.memory | default('256m') }}
{% endif %}
    networks:
      - traefik_proxy
    volumes:
      - /var/run/docker.sock:/var/run/docker.sock:ro
      - traefik-certificates:/letsencrypt
      - "/etc/localtime:/etc/localtime:ro"
    # configs:
      # - traefik.toml:/etc/traefik/traefik.toml
      # - source: traefik.toml
      #   target: /etc/traefik/traefik.toml
      #   uid: '103'
      #   gid: '103'
      #   mode: 0440
      # - source: htpasswd
      #   target: /etc/traefik/htpasswd

volumes:
  traefik-certificates:

# configs:
  # traefik.toml:
  #   external: true
  # htpasswd:
  #   external: true

networks:
  traefik_proxy:
    external:
      name: traefik_proxy
